{% extends 'profile/layouts/admin/admin_layout.html' %}

{% load static %}

{% block css %}
<link href="{% static 'admin/plugin/jstree/jstree.bundle.css' %}" rel="stylesheet" />

<style type="text/css">
    .height-100{
        height: 100% !important;
        width: 100% !important;
    }

    .wrap{
        white-space: wrap !important;
    }
</style>
{% endblock css %}

{% block navbar %}
    {% include 'profile/layouts/admin/navbar.html' %}
{% endblock navbar %}

{% block main %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{% url 'profile:admin_home' %}">Master Kegiatan</a></li>
            <li class="breadcrumb-item active" aria-current="page">Form Tambah Master Kegiatan</li>
        </ol>
    </nav>

    <form action="" method="POST" id="form_kegiatan" enctype="multipart/form-data">
        {% csrf_token %}
        <div class="card card-flush h-xl-100">
            <div class="card-body">
                <div class="col-8">
                    <div class="row mb-5">
                        <label class="col-lg-4 col-form-label required fw-semibold fs-6">Tahapan Saat Ini</label>
                        <div class="col-lg-8 fv-row fv-plugins-icon-container">
                            <input type="text" name="frm_tahapan_" id="frm_tahapan_" class="form-control form-control-lg form-control-solid" readonly required placeholder="Tahapan Aktif" value="{{tahapan_aktif}}">
                            <input type="hidden" name="frm_tahapan" id="frm_tahapan" class="form-control form-control-lg form-control-solid" readonly required value="{{tahapan_aktif_id}}">
                        <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback"></div></div>
                    </div>
                </div>
                <div class="col-12">
                    <div class="row">
                        <div class="col">
                            <div class="input-group mb-5 file-browser">
                                <input type="text" class="form-control browse-file" placeholder="Pilih File Excel (.xlsx) Dari Template" readonly="">
                                <label class="input-group-text btn btn-primary">
                                    Browse <input type="file" accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet" id="frm_file_excel" name="frm_file_excel" class="form-control file-browserinput" style="display:none;">
                                </label>
                            </div>
                            <h4><b><u>Petunjuk Import Data Kegiatan</u></b></h4>
                            <ul>
                                <li class="mt-2"><i class="fa fa-angle-double-right"></i> Download terlebih dahulu file template diatas atau <a class="btn btn-info btn-sm" href="">Download Template</a> </li>
                                <li class="mt-2"><i class="fa fa-angle-double-right"></i> Isikan kolom yang tersedia pada file excel</li>
                                <li class="mt-2"><i class="fa fa-angle-double-right"></i> Ikuti petunjuk pada file excel yang sudah disediakan</li>
                                <li class="mt-2"><i class="fa fa-angle-double-right"></i> Pilih file upload melalui tombol <b><i>Browse</i></b></li>
                                <li class="mt-2"><i class="fa fa-angle-double-right"></i> Tunggu proses upload sampai menampilkan review data</li>
                                <li class="mt-2"><i class="fa fa-angle-double-right"></i> Lalu klik import data</li>
                            </ul>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col text-right">
                            <h2>Total Anggaran: Rp. <span id="total_anggaran">0,00</span></h2>
                        </div>
                    </div>
                    <div class="row mt-2">
                        <div class="col">
                            <div id="kt_docs_jstree_basic"></div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="card-footer d-flex justify-content-end py-6 px-9">
                <a href="{% url 'profile:index_kegiatan' %}" class="btn btn-danger btn-active-light-primary mr-2">Batal</a>
                <button type="button" class="btn btn-success" id="btn_submit_skpd">Import</button>
            </div>
        </div>
    </form>

    <!-- <div class="card shadow mb-5">
        <div class="card-body">
            <form method ='post' enctype ="multipart/form-data" action="{% if edit %}{% url 'profile:admin_kegiatan_edit' kegiatan.id_kegiatan %} {% else %}{% url 'profile:admin_kegiatan_create' %} {% endif %} ">
                {% csrf_token %}
                <div class="row">
                    <div class="col-md-4 mt-3">
                        <div class="form-label"> Tahapan </div>
                        <input type="text" name="tahapan" class="form-control" readonly value="{{ tahapan.tahapan }}" required placeholder="Silahkan isi bagian">
                        <input type="hidden" name="id_tahapan" class="form-control" value="{{ tahapan.id_tahapan }}" required placeholder="Silahkan isi bagian">
                    </div>
                    <div class="col-md-3 mt-3">
                        <div class="form-label"> Tahun </div>
                        <input type="text" name="tahun" class="form-control" readonly value="{{ tahapan.tahun.tahun }}" required placeholder="Silahkan isi bagian">
                    </div>
                    <div class="col-md-5 mt-3">
                        <div class="form-label"> SKPD </div>
                        <select class="form-select form-control-sm form-select-solid select2 " style="width: 100%;" data-control="select2" name="skpd" aria-label="Select example" required>
                            <option value="" disabled selected>Pilih role</option>
                            {% for dt_skpd in skpd %}
                                <option {% if kegiatan.skpd.id == dt_skpd.id %}selected{% endif %} value="{{ dt_skpd.id }}">
                                    {{ dt_skpd.namaopd|title }}
                                </option>
                            {% endfor %}
                        </select>
                    </div>
                    <div class="col-md-5 mt-3">
                        <div class="form-label"> Bagian </div>
                        <input type="text" name="bagian" value="{{ kegiatan.bagian }}" class="form-control" required placeholder="Silahkan isi bagian">
                    </div>
                    <div class="col-md-7 mt-3">
                        <div class="form-label"> Program </div>
                        <input type="text" name="program" value="{{ kegiatan.program }}" class="form-control" required placeholder="Silahkan isi program">
                    </div>
                    <div class="col-md-6 mt-3">
                        <div class="form-label"> Kegiatan </div>
                        <input type="text" name="kegiatan" value="{{ kegiatan.kegiatan }}" class="form-control" required placeholder="Silahkan isi kegiatan">
                    </div>
                    <div class="col-md-6 mt-3">
                        <div class="form-label"> Sub Kegiatan </div>
                        <input type="text" name="subkegiatan" value="{{ kegiatan.sub_kegiatan }}" class="form-control" required placeholder="Silahkan isi sub kegiatan">
                    </div>
                </div>
                
                <div class="mt-3">
                    <a href="{% url 'profile:index_kegiatan' %}" class="btn btn-info" ><i class="fa fa-arrow-left px-1"></i>Kembali</a>
                    <button class="btn btn-primary" type="submit"><i class="fa fa-save"></i> Simpan</button>
                </div>
            </form>
        </div>
    </div> -->

{% endblock main %}

{% block footer %}
    {% include 'profile/layouts/admin/footer.html' %}
{% endblock footer %}

{% block scripts_bawah %}
<script src="{% static 'admin/plugin/jstree/jstree.bundle.js' %}"></script>
<script type="text/javascript">
    var array_kegiatan = [];

    $('#btn_submit_skpd').click(function(){
        if(check_required($('#form_kegiatan'))){
            var formData = new FormData($("#form_kegiatan")[0]);
            submit_form(formData)
        }else{
            show_notif('Silahkan cek data yang diinputkan, beberapa data masih kosong.', 'warning');
        }
    })

    $(document).on('change', '.file-browserinput', function() {
        var input = $(this),
        numFiles = input.get(0).files ? input.get(0).files.length : 1,
        label = input.val().replace(/\\/g, '/').replace(/.*\//, '');
    input.trigger('fileselect', [numFiles, label]);

    upload_file()
    });// We can watch for our custom `fileselect` event like this

    //______File Upload
    $('.file-browserinput').on('fileselect', function(event, numFiles, label) {
            
            var input = $(this).parents('.input-group').find(':text'),
            log = numFiles > 1 ? numFiles + ' files selected' : label;
            
            if( input.length ) {
                input.val(log);
            } else {
                if( log ) alert(log);
            }
    });

    function upload_file(){
        // e.preventDefault()
        // e.stopImmediatePropagation()
        var form = $('#form_kegiatan')
        var form_ = form[0];
        var f_obj = $("input[name=frm_file_excel]").get(0).files[0];
        
        var form_data = new FormData(form_);


         $.ajax({
              type: form.attr('method'),
              headers : { "X-CSRFToken": $("input[name=csrfmiddlewaretoken]").val() },
              url: "{% url 'profile:parse_kegiatan_excel' %}",
              data: form_data,
              cache: false,
              contentType: false,
              processData: false,
              dataType: 'json',
              success: function(data)
              {
                array_kegiatan = data.data_response

                console.log(array_kegiatan)

                $('#kt_docs_jstree_basic').jstree("destroy").empty()

                $('#kt_docs_jstree_basic').jstree({
                    "core" : {
                        "data" : array_kegiatan,
                    }
                });

                $('#total_anggaran').text(to_currency_indo(data.total_anggaran))
                form_.reset();
              },
              error: function(data){
                $('#kt_docs_jstree_basic').jstree("destroy").empty() 

                $('#total_anggaran').text('0,00')

                array_kegiatan = []

                var_tbl_gagal = ''
                
                try{
                    var data_gagal = data.responseJSON.data_gagal;
                }catch(err){
                    
                }

                Swal.fire({
                    title: "Oops...",
                    type: "warning",
                    icon: 'error',
                    showCancelButton: false,
                    confirmButtonText: 'OK',
                    html: `<p>${data.responseJSON.pesan}</p>${var_tbl_gagal}`,
                    // text: 
                }, function() {
                        location.reload();
                    });
              }
         });

         // form_.reset();
    };

    function submit_form(arg){
        if(array_kegiatan.length == 0){
            console.log(arg)
            show_notif('Silahkan lakukan Import Excel terlebih dahulu.', 'warning');
            return false;
        }

        arg.append("data_kegiatan", JSON.stringify(array_kegiatan))

        $.ajax({
             type: 'POST',
             headers : { "X-CSRFToken": $("input[name=csrfmiddlewaretoken]").val() },
             url: '',
             data: arg,
             processData: false,
             contentType: false,
             dataType: 'json',
             success: function(data)
             {
                show_notif(data.message,data.status);
                if(data.status == 'success'){
                    setTimeout(function(){
                        window.location.href = `{% url 'profile:index_kegiatan' %}`;
                    }, 3000);
                }
             },
             error: function(data){
                try{
                    show_notif(data.responseJSON.message,data.responseJSON.status);
                }catch(er){
                    show_notif('Terjadi Kesalahan Server.','error');
                }
             }
        });
    }

</script>   
{% endblock scripts_bawah %}